SystemOrganization addCategory: #MailSortingOffice!
SystemOrganization addCategory: 'MailSortingOffice-Core'!
SystemOrganization addCategory: 'MailSortingOffice-Morphic'!
SystemOrganization addCategory: 'MailSortingOffice-Test'!

Object subclass: #MailSortingOffice
	instanceVariableNames: 'mailStream pigeonHoles missionMessage undoRedo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MailSortingOffice-Core'!

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:41'!
canUndo
	^self undoRedo canUndo! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:39'!
currentMail
	^mailStream isEmpty
		ifTrue: [nil]
		ifFalse: [mailStream first]! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:24'!
mails: aSequenceableCollection 
	mailStream := OrderedCollection withAll: aSequenceableCollection! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 02:35'!
makePigeonHoles: anInteger 
	self makePigeonHolesWithNames: ( (1 to: anInteger) collect: [:each| each printString] )! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:24'!
makePigeonHolesWithNames: aCollection 
	
	| streamSize |
	streamSize := mailStream ifNil: [10] ifNotNil: [(mailStream size / aCollection size) ceiling].
	pigeonHoles := aCollection collect: [:string| (PigeonHole new name: string; stack: (OrderedCollection new: streamSize)) ].! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:39'!
missionMessage
	^ missionMessage! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:38'!
missionMessage: aString 
	missionMessage := aString! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 02:10'!
numberOfPigeonHolds
	^pigeonHoles size! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:27'!
pickUpFromPigeonHoleAtIndex: anInteger 
	mailStream addFirst: (self pigeonHoles at: anInteger) stack removeFirst! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:09'!
pigeonHoleContents
	^pigeonHoles collect: [ :each| each stack asArray ]! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:19'!
pigeonHoles
	^ pigeonHoles! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:37'!
tossCurrentMailIntoPigeonHoleAtIndex: anInteger 
	[ mailStream isEmpty not ] assert.
	(pigeonHoles at: anInteger) stack addFirst: mailStream removeFirst.
	self undoRedo add: anInteger.! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:34'!
undo
	|which|
	which := self undoRedo currentItem.
	self pickUpFromPigeonHoleAtIndex: which.
	self undoRedo undo.
	^which! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:19'!
undoRedo
	^undoRedo setDefault: #undoRedoDefault for: self withSetter: #undoRedo:! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:20'!
undoRedo: anUndoRedo 
	undoRedo := anUndoRedo! !

!MailSortingOffice methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:20'!
undoRedoDefault
	^UndoRedo new! !

Object subclass: #MailSortingOfficeController
	instanceVariableNames: 'model pigeonHoleMorphs currentMailMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MailSortingOffice-Morphic'!

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 04:31'!
currentMail
	^model currentMail printString! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 04:56'!
missionMessage
	^'"',model missionMessage,'"'! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 02:11'!
model: aMailSortingOffice 
	model := aMailSortingOffice! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:37'!
numberKeyPressed: anInteger 
	|exit|
	exit := [:af| ^self inform: 'no more'].
	[[model tossCurrentMailIntoPigeonHoleAtIndex: anInteger] on: SubscriptOutOfBounds do: exit] on: AssertionFailure do: exit.
	(pigeonHoleMorphs at: anInteger) updatePigeonHole.
	self changed: #currentMail! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:04'!
open
	| q window msg labelHeight margin |
	labelHeight := 30.
	margin := 30.
	q := QuickPrototyping for: self.
	window := StandardWindow new.
	msg := q label: #missionMessage.
	window addMorph: (msg) frame: (LayoutFrame new leftFraction: 0 ; leftOffset: margin; rightFraction: 1; rightOffset: margin negated; topFraction: 0; topOffset: margin;bottomFraction: 0; bottomOffset: margin+labelHeight+margin).
	msg color: Color black.
	msg font: (StandardFonts windowTitleFont).
	currentMailMorph := q label: #currentMail.
	window addMorph: (currentMailMorph) frame: (LayoutFrame new leftFraction: 0 ; leftOffset: margin; rightFraction: 1; rightOffset: margin negated; topFraction: 0; topOffset: margin+labelHeight+margin; bottomFraction: 0; bottomOffset: margin+labelHeight+margin+labelHeight+margin).
	currentMailMorph color: Color black.
	currentMailMorph font: (StandardFonts windowTitleFont).
	pigeonHoleMorphs := OrderedCollection new.
	model pigeonHoles keysAndValuesDo: [:th :each| 
		|pm|
		pm := PigeonHoleMorph new model: each.
		pigeonHoleMorphs add: pm. window addMorph: pm frame: (LayoutFrame fractions: (((th-1)/model pigeonHoles size)@0 extent:  (1 / model pigeonHoles size)@1 ) offsets: (0@(margin+labelHeight+margin+labelHeight+margin) corner: 0@ 0)).
		window on: (Character digitValue: th) do: [self numberKeyPressed: th ] ].
	window setLabel: 'Mail Sorting Office'.
	window openInWorld.
	window on: $z do: [ self undo ].
	pigeonHoleMorphs do: [ :each| each updatePigeonHole ]! !

!MailSortingOfficeController methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:41'!
undo
	model canUndo
		ifTrue: 
			[| pigeonHoleIndex |
			pigeonHoleIndex := model undo.
			(pigeonHoleMorphs at: pigeonHoleIndex) updatePigeonHole.
			self changed: #currentMail]
		ifFalse: [ self inform: 'Cannot undo.' ]! !

Object subclass: #PigeonHole
	instanceVariableNames: 'name writeStream stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MailSortingOffice-Core'!

!PigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:02'!
name
	^name! !

!PigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 02:37'!
name: aString 
	name := aString! !

!PigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:08'!
stack
	^stack! !

!PigeonHole methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:08'!
stack: anOrderedCollection
	stack := anOrderedCollection! !

Morph subclass: #PigeonHoleMorph
	instanceVariableNames: 'model nameMorph listMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MailSortingOffice-Core'!

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:15'!
initialize
	| q |
	super initialize.
	self layoutPolicy: ProportionalLayout new.
	self color: Color gray.
	q := QuickPrototyping for: self.
	nameMorph := q label: #nameString.
	self addMorph: nameMorph fullFrame: (LayoutFrame new leftFraction: 0 ; leftOffset: 1; rightFraction: 1; rightOffset: -1; topFraction: 0; bottomFraction: 0; bottomOffset: 14).
	listMorph := q fastList: #item.
	self addMorph: listMorph fullFrame: (LayoutFrame new leftFraction: 0; leftOffset: 1; rightFraction: 1; rightOffset: -1; topFraction: 0; topOffset: 20; bottomFraction: 1; bottomOffset: -1).
	self extent: 90@180.! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:30'!
itemListElementAt: anInteger 
	^model stack at: anInteger! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:04'!
itemListIndex
	^0! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:12'!
itemListIndex: anInteger 
	! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:17'!
itemListSize
	^model
		ifNil: [ 0 ]
		ifNotNil: [ model stack size ]! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 02:42'!
model: aPigeonHole 
	model := aPigeonHole ! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:00'!
nameString
	^model
		ifNil: [ 'no model yet' ]
		ifNotNil: [ model name ]! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:27'!
openInWorld: aMorph
	super openInWorld: aMorph.
	self updatePigeonHole! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:27'!
update: aSymbol.
	aSymbol = #pigeonHole ifTrue: [ self updatePigeonHole ].
	super update: aSymbol.! !

!PigeonHoleMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 03:27'!
updatePigeonHole

	self changed: #nameString.
	self changed: #itemListElementAt:.! !

TestCase subclass: #MailSortingOfficeTest
	instanceVariableNames: 'office'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MailSortingOffice-Test'!

!MailSortingOfficeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 02:28'!
setUp
	super setUp.
	office := MailSortingOffice new.
	office mails: 'hello world'.
! !

!MailSortingOfficeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 02:28'!
testNumberOfPigeonHolds
	
	office makePigeonHoles: 3.

	self assert: office numberOfPigeonHolds equals: 3.! !

!MailSortingOfficeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:37'!
testPigeonHolesWithNames

	office makePigeonHolesWithNames: {'vowel'. 'consonant'}.

	self assert: office pigeonHoleContents equals: #(() ()).

	self assert: office currentMail equals: $h.
	office tossCurrentMailIntoPigeonHoleAtIndex: 2.
	self assert: office pigeonHoleContents equals: #(() ($h)).

	self assert: office currentMail equals: $e.
	office tossCurrentMailIntoPigeonHoleAtIndex: 1.	
	self assert: office pigeonHoleContents equals: #(($e) ($h)).

	self assert: office currentMail equals: $l.
	office tossCurrentMailIntoPigeonHoleAtIndex: 2.
	self assert: office pigeonHoleContents equals: #(($e) ($l $h)).
	
	self assert: office currentMail equals: $l.
	office tossCurrentMailIntoPigeonHoleAtIndex: 2.
	
	self assert: office pigeonHoleContents equals: #(($e) ($l $l $h)).
	self assert: office currentMail equals: $o.

	office tossCurrentMailIntoPigeonHoleAtIndex: 1.	
	self assert: office pigeonHoleContents equals: #(($o $e) ($l $l $h)).

! !

!MailSortingOfficeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:37'!
testPigeonHolesWithNamesUndo

	office makePigeonHolesWithNames: {'vowel'. 'consonant'}.

	self assert: office pigeonHoleContents equals: #(() ()).

	self assert: office currentMail equals: $h.
	office tossCurrentMailIntoPigeonHoleAtIndex: 2.
	self assert: office pigeonHoleContents equals: #(() ($h)).

	self assert: office currentMail equals: $e.
	office tossCurrentMailIntoPigeonHoleAtIndex: 1.	
	self assert: office pigeonHoleContents equals: #(($e) ($h)).

	self assert: office currentMail equals: $l.
	office tossCurrentMailIntoPigeonHoleAtIndex: 2.
	self assert: office pigeonHoleContents equals: #(($e) ($l $h)).
	
	office undo.
	self assert: office currentMail equals: $l.
	self assert: office pigeonHoleContents equals: #(($e) ($h)).
	
	office undo.
	self assert: office currentMail equals: $e.
	self assert: office pigeonHoleContents equals: #(() ($h)).! !

!MailSortingOfficeTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/24/2014 05:37'!
testTossCurrentMailIntoPigeonHoleAtIndex

	office makePigeonHoles: 3.

	self assert: office pigeonHoleContents equals: #(() () ()).

	self assert: office currentMail equals: $h.
	office tossCurrentMailIntoPigeonHoleAtIndex: 2.
	self assert: office pigeonHoleContents equals: #(() ($h) ()).

	self assert: office currentMail equals: $e.	
	office tossCurrentMailIntoPigeonHoleAtIndex: 3.
	self assert: office pigeonHoleContents equals: #(() ($h) ($e)).

	self assert: office currentMail equals: $l.
	office tossCurrentMailIntoPigeonHoleAtIndex: 3.
	self assert: office pigeonHoleContents equals: #(() ($h) ($l $e)).
	
	self assert: office currentMail equals: $l.	
	office tossCurrentMailIntoPigeonHoleAtIndex: 1.
	self assert: office pigeonHoleContents equals: #(($l) ($h) ($l $e)).
	
	self assert: office currentMail equals: $o.
	office tossCurrentMailIntoPigeonHoleAtIndex: 1.
	self assert: office pigeonHoleContents equals: #(($o $l) ($h) ($l $e)).
! !
